/*********************************************
 * INSECURE HASH ALGORITHM-1 (IHA-1)         *
 * input: the file to hash                   *
 * output: the digest = 1 hexadecimal digit  *
 ********************************************/

#include <stdio.h>

int main (int argc, char *argv[])
{
   FILE *file_in;
   int xc;
   int hash = 0;

   if (argc  != 2) {
      fprintf (stderr,"usage: %s file\n", argv[0]);
      return 1;
   }

   file_in = fopen(argv[1],"r");
   if(file_in == NULL) {
      fprintf (stderr,"error: can't open file '%s' for reading\n", argv[1]);
      return 2;
   }

   while ((xc=fgetc(file_in)) != EOF)
      hash ^= xc;

   printf ("iha1(%s) = %X\n", argv[1], hash % 16);

   if (fclose(file_in) != 0)
      fprintf (stderr, "warning: failure when closing file '%s'", argv[1]);

   return 0;
}
